Object.equals = function (x, y) {
    if (x === y) return true;
    if (!(x instanceof Object) || !(y instanceof Object)) return false;
    if (x.constructor !== y.constructor) return false;

    for (var p in x) {
        if (!x.hasOwnProperty(p)) continue;
        if (!y.hasOwnProperty(p)) return false;
        if (x[p] === y[p]) continue;
        if (typeof x[p] !== "object") return false;
        if (!Object.equals(x[p], y[p])) return false;
    }

    for (p in y) {
        if (y.hasOwnProperty(p) && !x.hasOwnProperty(p)) return false;
    }
    return true;
};



let AutoTuner = function () { };

AutoTuner.prototype.run = function () {
    try {
        let extenders = false;
        for (i in virtualZone) {
            if (virtualZone[i].typeDev === "ext") {
                extenders = !extenders ? !extenders : extenders;
            }
        }
        if (extenders) {
            alert("Не удалось выполнить автонастройку. Удалите расширители из конфигурации прибора.");
        }
        else {
            //return this.allDevice();
            this.deviceNeedTune();
            this.fixDevice();
        }
    } catch (error) {
        console.log(error);
    }
};


AutoTuner.prototype.btnDisplay = function () {
    try {
        if (DEVICEMODEL.indexOf('208') != -1) {
            let extenders = false;
            for (i in virtualZone) {
                if (virtualZone[i].typeDev === "ext") {
                    extenders = !extenders ? !extenders : extenders;
                }
            }
            if (extenders) {
                return false
            } else {
                return true
            }
        } else {
            return false;
        }
    } catch (error) {
        console.log(error);
    }
};


AutoTuner.prototype.allDevice = function () {
    this.DeviceAll = [];
    try {
        for (i in deviceJSON.config) {
            if (
                deviceJSON.config[i].key.indexOf("xxad") != -1 &&
                deviceJSON.config[i].key !== "xxad0"
            ) {
                if (deviceJSON.config[i].subvalues[1].value !== "0") {
                    let device = {};
                    device.adress = deviceJSON.config[i].key.slice(4);
                    let XXDR = "xxdr" + device.adress;
                    device.sensor1 = this.parseKey()[XXDR][0].value;
                    device.sensor2 = this.parseKey()[XXDR][1].value;
                    this.DeviceAll.push(device);
                }
            }
        }
        return this.DeviceAll;
    } catch (error) {
        spiner_stop();
        console.log(error);
        alert("Не удалось выполнить автонастройку");
        return "error";
    }
};

AutoTuner.prototype.deviceNeedTune = function () {
    this.device = [];
    try {
        for (i in deviceJSON.config) {
            if (
                deviceJSON.config[i].key.indexOf("xxad") != -1 &&
                deviceJSON.config[i].key !== "xxad0"
            ) {
                if (deviceJSON.config[i].subvalues[1].value !== "0") {
                    let device = {};
                    device.adress = deviceJSON.config[i].key.slice(4);
                    let XXDR = "xxdr" + device.adress;
                    let XXAD = "xxad" + device.adress;
                    device.sensor1 = this.parseKey()[XXDR][0].value;
                    device.sensor2 = this.parseKey()[XXDR][1].value;

                    if (
                        (device.adress !== device.sensor1 && device.sensor1 !== "0") ||
                        (100 + parseInt(device.adress) !== parseInt(device.sensor2) &&
                            device.sensor2 !== "0")
                    ) {
                        let LW1 = "lw" + this.parseKey()[XXDR][0].value;
                        let LW2 = "lw" + this.parseKey()[XXDR][1].value;
                        let YZ1 = "yz" + this.parseKey()[XXDR][0].value;
                        let YZ2 = "yz" + this.parseKey()[XXDR][1].value;
                        device.config = (function () {
                            let res = {};
                            for (k in deviceJSON.config) {
                                if (
                                    deviceJSON.config[k].key === LW1 ||
                                    deviceJSON.config[k].key === LW2 ||
                                    deviceJSON.config[k].key === YZ1 ||
                                    deviceJSON.config[k].key === YZ2 ||
                                    deviceJSON.config[k].key === XXDR ||
                                    deviceJSON.config[k].key === XXAD
                                ) {
                                    res[deviceJSON.config[k].key] = deviceJSON.config[k];
                                }
                            }
                            return res;
                        })();
                        this.device.push(device);
                    }
                }
            }
        }
        return this.device;
    } catch (error) {
        spiner_stop();
        console.log(error);
        alert("Не удалось выполнить автонастройку");
        return "error";
    }
};

AutoTuner.prototype.parseKey = function () {
    try {
        this.Key = {};
        for (i in deviceJSON.config) {
            this.Key[deviceJSON.config[i].key] = deviceJSON.config[i].subvalues;
        }
        return this.Key;
    } catch (error) {
        spiner_stop();
        console.log(error);
        alert("Не удалось выполнить автонастройку");
        return "error";
    }
};

AutoTuner.prototype.createDevice = function (deviceList) {
    this.Device = {};
    try {
        for (i in deviceJSON.config) {
            if (
                deviceJSON.config[i].key.indexOf("xxad") != -1 &&
                deviceJSON.config[i].key !== "xxad0"
            ) {
                if (deviceJSON.config[i].subvalues[1].value === "0") {
                    let device = {};
                    device.adress = deviceJSON.config[i].key.slice(4);
                    let XXDR = "xxdr" + device.adress;
                    let LW1 = "lw" + this.parseKey()[XXDR][0].value;
                    let LW2 = "lw" + this.parseKey()[XXDR][1].value;
                    let YZ1 = "yz" + this.parseKey()[XXDR][0].value;
                    let YZ2 = "yz" + this.parseKey()[XXDR][1].value;
                    device.sensor1 = device.adress;
                    device.sensor2 = 100 + parseInt(device.adress) + "";
                    device.options = (function () {
                        let res = [];
                        for (k in deviceJSON.config) {
                            if (
                                deviceJSON.config[k].key === LW1 ||
                                deviceJSON.config[k].key === LW2 ||
                                deviceJSON.config[k].key === YZ1 ||
                                deviceJSON.config[k].key === YZ2
                            ) {
                                res.push(deviceJSON.config[k]);
                            }
                        }
                        return res;
                    })();
                    return (this.Device = device);
                }
            }
        }
        return this.Device;
    } catch (error) {
        spiner_stop();
        console.log(error);
        alert("Не удалось выполнить автонастройку");
        return "error";
    }
};

AutoTuner.prototype.fixDevice = function (deviceList) {
    try {
        let error = false;
        if (this.parseKey()['zs']) {
            let integralZoneArr = this.parseKey()['zs'][0].value ? this.parseKey()['zs'][0].value.split(',') : [];
            if (integralZoneArr.length == 1) {
                if (integralZoneArr[0] == '1') {
                    if (this.parseKey()['lw193'][0].value === '0' && this.parseKey()['lw193'][1].value === '0' && this.parseKey()['lw193'][2].value === '0' || this.parseKey()['zs'][1].value == '193') {
                        if (this.parseKey()['zs'][1].value !== '193') {
                            for (k in deviceJSON.config) {
                                if (deviceJSON.config[k].key == 'lw193') {
                                    deviceJSON.config[k].subvalues[0].value = this.parseKey()['lw1'][0].value;
                                    deviceJSON.config[k].subvalues[1].value = this.parseKey()['lw1'][1].value;
                                    deviceJSON.config[k].subvalues[2].value = this.parseKey()['lw1'][2].value;
                                    saveConfig(deviceJSON.config[k]);
                                } else if (deviceJSON.config[k].key == 'zs') {
                                    deviceJSON.config[k].subvalues[0].value = '1'
                                    deviceJSON.config[k].subvalues[1].value = '193';
                                    saveConfig(deviceJSON.config[k]);
                                } else if (deviceJSON.config[k].key == 'yz193') {
                                    deviceJSON.config[k].subvalues[0].value = this.parseKey()['yz1'][0].value;
                                    saveConfig(deviceJSON.config[k]);
                                }
                            }
                        }
                    } else {
                        error = !error;
                        console.log("Не удалось выполнить автонастройку, измените номер зоны 1 либо освободите 193 зону");
                    }
                }
            }
        }
        if (!error) {
            for (i in this.device) {
                let xxdrKey = 'xxdr' + this.device[i].adress;
                let lwKey1 = 'lw' + this.device[i].adress;
                let lwKey2 = 'lw' + (100 + parseInt(this.device[i].adress));
                let yz1 = 'yz' + this.device[i].adress;
                let yz2 = 'yz' + (100 + parseInt(this.device[i].adress));

                let olddSensor1 = this.device[i].config['xxdr' + this.device[i].adress].subvalues[0].value;
                let olddSensor2 = this.device[i].config['xxdr' + this.device[i].adress].subvalues[1].value;

                let oldLwKey1 = 'lw' + olddSensor1;
                let oldLwKey2 = 'lw' + olddSensor2;
                let oldYz1 = 'yz' + olddSensor1;
                let oldYz2 = 'yz' + olddSensor2;

                for (k in deviceJSON.config) {
                    if (deviceJSON.config[k].key == xxdrKey) {
                        deviceJSON.config[k].subvalues[0].value = this.device[i].adress;
                        deviceJSON.config[k].subvalues[1].value = 100 + parseInt(this.device[i].adress) + "";
                        saveConfig(deviceJSON.config[k]);
                    } else if (deviceJSON.config[k].key == lwKey1) {
                        deviceJSON.config[k].subvalues[0].value = this.device[i].config[oldLwKey1].subvalues[0].value;
                        deviceJSON.config[k].subvalues[1].value = this.device[i].config[oldLwKey1].subvalues[1].value;
                        deviceJSON.config[k].subvalues[2].value = this.device[i].config[oldLwKey1].subvalues[2].value;
                        saveConfig(deviceJSON.config[k]);
                    } else if (deviceJSON.config[k].key == lwKey2) {
                        deviceJSON.config[k].subvalues[0].value = this.device[i].config[oldLwKey2].subvalues[0].value;
                        deviceJSON.config[k].subvalues[1].value = this.device[i].config[oldLwKey2].subvalues[1].value;
                        deviceJSON.config[k].subvalues[2].value = this.device[i].config[oldLwKey2].subvalues[2].value;
                        saveConfig(deviceJSON.config[k]);
                    } else if (deviceJSON.config[k].key == yz1) {
                        deviceJSON.config[k].subvalues[0].value = this.device[i].config[oldYz1].subvalues[0].value;
                        saveConfig(deviceJSON.config[k]);
                    } else if (deviceJSON.config[k].key == yz2) {
                        deviceJSON.config[k].subvalues[0].value = this.device[i].config[oldYz2].subvalues[0].value;
                        saveConfig(deviceJSON.config[k]);
                    }
                }
            }


            return parseAppKey('update_notabs');
        } else {
            return alert("Не удалось выполнить автонастройку");
        }
        //return deviceList;
    } catch (error) {
        spiner_stop();
        console.log(error);
        alert("Не удалось выполнить автонастройку");
        return "error";
    }
};

AutoTuner.prototype.saveDevice = function (device) {
    try {
        for (i in device) {
            console.log(device[i]);
        }
    } catch (error) {
        spiner_stop();
        console.log(error);
        alert("Не удалось выполнить автонастройку");
        return "error";
    }
};

AutoTuner.prototype.removeDevice = function (device) {
    try {
        for (d in device) {
            let XXAD = "xxad" + device[d].adress;
            let XXDR = "xxdr" + device[d].adress;
            let LW1 = "lw" + device[d].sensor1;
            let LW2 = "lw" + device[d].sensor2;

            for (i in deviceJSON.config) {
                if (deviceJSON.config[i].key == XXAD) {
                    deviceJSON.config[i].subvalues[0].value = "0";
                    deviceJSON.config[i].subvalues[1].value = "0";
                    deviceJSON.config[i].subvalues[2].value = "0";
                    deviceJSON.config[i].subvalues[3].value = "0";
                    saveConfig(deviceJSON.config[i]);
                } else if (
                    deviceJSON.config[i].key == XXDR ||
                    deviceJSON.config[i].key == LW1 ||
                    deviceJSON.config[i].key == LW2
                ) {
                    deviceJSON.config[i].subvalues[0].value = "0";
                    deviceJSON.config[i].subvalues[1].value = "0";
                    saveConfig(deviceJSON.config[i]);
                }
            }
        }
    } catch (error) {
        spiner_stop();
        console.log(error);
        alert("Не удалось выполнить автонастройку");
        return "error";
    }
};
